const { app } = require("electron");
const path = require('path')
const { platforms, windowsConfig, appPath } = require("../../constants/core")

class StartUpApp {
    static run = () => {
        switch(process.platform) {
            case platforms.linux: 
                const AutoLaunch = require("../../utils/autoLaunch");
                AutoLaunch.generateDesktopFileLinux()
                break;
                case platforms.win: 
                const regedit = require('regedit');
                const { autoRun: { key, appName } } = windowsConfig;
                regedit.putValue({
                    [key]: {
                        [appName]: {
                            value: appPath,
                            type: 'REG_SZ', 
                        }
                    }
                }, (err) => {
                    if (err) {
                        console.error('Error setting registry value:', err);
                    } else {
                        console.log('Registry value set successfully.');
                    }
                })
                break;
            case platforms.freeBSD: 
            case platforms.macOS:
                const Store = require('electron-store');
                const store = new Store();
                const cacheData = store.get('teamChatCache');
                if (!cacheData?.autoRun) store.set('teamChatCache', { autoRun: true });
                const currentSettings = app.getLoginItemSettings();
                if (!currentSettings.openAtLogin) {
                app.setLoginItemSettings({
                    openAtLogin: true,
                    path: appPath,
                    args: [
                    '--processStart', `"${path.basename(appPath)}"`
                    ]
                });
                }
                return;
            case platforms.sunOS: 
            default: break;
        }
    }
}

module.exports = StartUpApp;