const fs = require('fs');
const path = require('path');

class AutoLaunch {
   static path = path.join(process.env.HOME, '.config', 'autostart', 'webwork-chat-autorun.desktop');
   static filePayload = (autoStart) => `[Desktop Entry]
Type=Application
Exec="/opt/WebWork Chat/webwork-chat"
Hidden=false
NoDisplay=false
X-GNOME-Autostart-enabled=${autoStart}
Name[en_GB]=WebWork Chat
Name=WebWork Chat
Comment[en_GB]=WebWork Chat Autorun
Comment=WebWork Chat Autorun`

    static enable() {
        const desktopFileContent = AutoLaunch.filePayload(true);
        fs.writeFileSync(AutoLaunch.path, desktopFileContent);
    }
    static disable() {
        const desktopFileContent = AutoLaunch.filePayload(false);
        fs.writeFileSync(AutoLaunch.path, desktopFileContent);
    }
    static generateDesktopFileLinux() {
        const desktopFileContent = AutoLaunch.filePayload(true);
        if (!fs.existsSync(AutoLaunch.path)) return fs.writeFileSync(AutoLaunch.path, desktopFileContent);
        if (fs.readFileSync(AutoLaunch.path, 'utf8').includes('X-GNOME-Autostart-enabled=false')) return;
        fs.writeFileSync(AutoLaunch.path, desktopFileContent);
    }
}

module.exports = AutoLaunch