const { Menu, MenuItem } = require("electron");
const { appVersion } = require("../../constants/core.js");

class MainHelper {
    static copyPastLogic = ({ isEditable, selectionText }) => {
        const menu = new Menu();
        if (isEditable) {
          if(selectionText) {
            menu.append(new MenuItem({ label: 'Cut', role: 'cut' }));
            menu.append(new MenuItem({ label: 'Paste', role: 'paste' }));
            menu.popup();
          }
          else {
            menu.append(new MenuItem({ label: 'Paste', role: 'paste' }));
            menu.popup();
          }
        }
        if (selectionText) {
          menu.append(new MenuItem({ label: 'Copy', role: 'copy' }));
          menu.popup();
        }
    }
    static async setAppVersionToLocalStorage(mainWindow) {
      mainWindow.webContents.executeJavaScript(`localStorage.setItem("appVersion", "${appVersion}");`, true)
    } 
}

module.exports = MainHelper;